# net-suite frontend

## Development setup

The initial setup consists of the following steps:

1. Install the following `pip`-module using `git` to be able to generate api configurations
   ```shell
   pip3 install git+https://git.scc.kit.edu/scc-net/net-suite/api-generator.git@master#egg=net-api-generator
   ```
2. Enter the `frontend` folder using
   ```shell
   cd frontend/
   ```
3. Generate API-Endpoints in `frontend/public/api.yml` using
    ```
    net-api-generator openapi --default_endpoint=devel > public/api.yml
    ```
   Instead of creating the api configuration for `devel`, `test` can also be used.
   Additionally, you need generate the files for the `api-services.gen` folder using the following command
   ```shell
   net-api-generator es-webpack
   ```
   You can add a `--version=${API_VERSION}` parameter, if you need a specific version.
4. Create a netvs-configuration `netvs.config.js`. See `netvs.config.js.example` for more information. In most cases it's enough to simply copy and rename the example config.
5. 
   1. Set the `FONTAWESOME_NPM_AUTH_TOKEN` environment variable 
   2. Run the development server either with `docker` and `docker-compose` (recommended way) 
      ```shell
      docker-compose up -d netvs-core_run
      ```
      or by running a local server (which we discourage from) after installing the project using the following two commands
       ```shell
       npm install
       npm run serve
       ```

### Local project setup
```
FONTAWESOME_NPM_AUTH_TOKEN=<token> npm install
```

### Compiles and minifies for production
```
npm run build
```

### Run your tests
```
npm run test
```

### Lints and fixes files
```
npm run lint
```

### Customize configuration
See [Configuration Reference](https://cli.vuejs.org/config/).
