import TransactionService from './transaction.service'

export default {
  list (config, own) {
    const ta = [
      { name: 'cntl.group.list', old: { is_admin_or_is_own: own, sorting_params_list: ['name'] } },
      { name: 'cntl.mgr2group.list', join: { 0: 'default'}, old: { sorting_params_list: ['group_name asc', 'mgr_login_name asc'] }},
      { name: 'nd.bcd2group.list', join: { 0: 'default'}, old: { sorting_params_list: ['group_name asc', 'bcd_name asc'] }},
      { name: 'dns.fqdn2group.list', join: { 0: 'default'}, old: { sorting_params_list: ['group_name', 'fqdn_value'] } },
      { name: 'cntl.mgr.list', join: { 1: 'default'} },
      { name: 'nd.bcd.list', join: { 2: 'default'} }
    ]
    return TransactionService.execute(config, ta)
  },
  get_by_name (config, name) {
    const ta = [
      { name: 'cntl.group.list', old: { name: name } },
      { name: 'cntl.mgr2group.list', join: { 0: 'default'}, old: { sorting_params_list: ['group_name asc', 'mgr_login_name asc'] }},
      { name: 'nd.bcd2group.list', join: { 0: 'default'}, old: { sorting_params_list: ['group_name asc', 'bcd_name asc'] }},
      { name: 'dns.fqdn2group.list', join: { 0: 'default'}, old: { sorting_params_list: ['group_name', 'fqdn_value'] } },
      { name: 'cntl.mgr.list', join: { 1: 'default'} },
      { name: 'nd.bcd.list', join: { 2: 'default'} }
    ]
    return TransactionService.execute(config, ta)
  }
}
