import Axios from 'axios'
import TransactionService from './transaction.service'

export default {
  pollJob(config, job) {
    return Axios.get('/api/macfinder/job/' + job, config)
  },
  createJob(config, bcd, mac) {
    return Axios.post('/api/macfinder/job', { bcd: bcd, mac: mac }, config)
  },
  ouiLookup(mac) {
    return Axios.get('/api/macfinder/oui_lookup?mac=' + mac)
  },
  resolveOutlet(config, bcd, device, port) {
    const ta = [
      { name: 'nd.bcd.list', old: { name: bcd } }, // BCDs
      { name: 'nd.vlan.list', join: { 0: 'default' } },
      { name: 'nd.l_port.list', join: { 1: 'default' }, old: { dev_fqd: device } },
      { name: 'nd.l2p_port.list', join: { 2: 'default' } },
      { name: 'nd.p_port.list', join: { 3: 'default' }, old: { name: port } },
      { name: 'nd.p_port.list', old_ref: { gpk: { idx: 4, param: 'dest_connected_gfk' } } }
    ]
    return TransactionService.execute(config, ta)
  }
}
