import TransactionService from './transaction.service'

export default {
  getOU(config, ou) {
    const ta = [
      { name: 'org.unit.list', old: { do_subtree: true, short_name: ou } },
      { name: 'cntl.mgr2ou.list', join: { 0: 'default' } },
      { name: 'cntl.mgr.list', join: { 1: 'default' } },
      { name: 'dns.fqdn2ou.list', join: { 0: 'default' } },
      { name: 'nd.bcd2ou.list', join: { 0: 'default' } },
      { name: 'nd.bcd.list', join: { 4: 'default' } },
      { name: 'cntl.group.list', join: { 0: 'default' } }
    ]
    return TransactionService.execute(config, ta)
  },
  listOwn(config) {
    const ta = [
      { name: 'cntl.mgr2ou.list', old: { is_own: true } },
      { name: 'org.unit.list', join: { 0: 'default' }, old: { do_subtree: true } },
      { name: 'cntl.mgr2ou.list', join: { 1: 'default' } },
      { name: 'cntl.mgr.list', join: { 2: 'default' } },
      { name: 'dns.fqdn2ou.list', join: { 1: 'default' } },
      { name: 'nd.bcd2ou.list', join: { 1: 'default' } },
      { name: 'nd.bcd.list', join: { 5: 'default' } },
      { name: 'org.unit.list', join: { 0: 'api_fkey_cntl_mgr2ou_ou' } }
    ]
    return TransactionService.execute(config, ta)
  },
  listAll(config) {
    const ta = [
      { name: 'org.unit.list', old: { do_subtree: true } },
      { name: 'cntl.mgr2ou.list', join: { 0: 'default' } },
      { name: 'cntl.mgr.list', join: { 1: 'default' } },
      { name: 'dns.fqdn2ou.list', join: { 0: 'default' } },
      { name: 'nd.bcd2ou.list', join: { 0: 'default' } },
      { name: 'nd.bcd.list', join: { 4: 'default' } }
    ]
    return TransactionService.execute(config, ta)
  }
}
